' Copyright (c) PIXILAB Technologies AB, Sweden (http://pixilab.se). All Rights Reserved.
' Created 2017 by Mike Fahl.

Sub Main()
	'Configurable parameters: ----------------------------------------
	videoMode = "1920x1080x50p"
	transform = "identity"	'Screen rotation; one of "identity", "rot90", "rot270"
	serverAddress = "pixi.guide"

	network = CreateObject("roNetworkConfiguration", 0)

	'Use dynamic address
	network.SetDHCP()

	'OR set fixed IP address of player, if required, to be independent of DHCP
	'If so, comment the line above, uncomment the following lines, and set desired values
	'network.SetIP4Address("192.168.0.25")
	'network.SetIP4Netmask("255.255.255.0")
	'network.SetIP4Broadcast("192.168.0.255")
	'network.SetIP4Gateway("192.168.0.1")

	'Dagnostic web server settings
	dwsEnabled$ = "no" ' Change to "yes" to enable
	dwsPassword$ = "A864386D766BFA930A901BA1C856D1976D9A4999B0A74DC6D4C1C8D0D20CE1CE4"
	'pixi

	'No user configurable values below this line
	'--END CONFIGURATION------------------------------------------------

	scriptVer = "2.1"
	network.Apply()	'Make it "take" above settings

	video = CreateObject("roVideoMode")
	video.SetMode(videoMode)

	'Enable Diagnostics Web Server
	registry = CreateObject("roRegistry")
	registrySection = CreateObject("roRegistrySection", "networking")
	if type(registrySection) = "roRegistrySection" then 

		registrySection.Write("dwse", dwsEnabled$)
		registrySection.Write("dwsp", dwsPassword$)

		' set DWS on device
		network = CreateObject("roNetworkConfiguration", 0)

		' Select alternate interface (wifi?), if didn't get primary
		'if type(network) <> "roNetworkConfiguration" then
		'	network = CreateObject("roNetworkConfiguration", 1)
		'endif

		if type(network) = "roNetworkConfiguration" then
			'dwsConfig = CreateObject("roAssociativeArray")
			if dwsEnabled$ = "yes" then
				dwsConfig = {
					port: 80
					password: dwsPassword$
				}
			else
				dwsConfig = {
					port: 0
				}
			endif

			rebootRequired = network.SetupDWS(dwsConfig)
		endif
		
		
		'telnet enable
		'registrySection.write("telnet","23")
		
		'telnet disable
		registrySection.delete("telnet")
		
		registrySection.Flush()
	endif
	registry.Flush()
	
	dispRect = CreateObject("roRectangle", 0, 0, video.GetOutputResX(), video.GetOutputResY())
	html = CreateObject("roHtmlWidget", dispRect)

	msgPort = CreateObject("roMessagePort")
	html.SetPort(msgPort)	'Msg port for browser and timer comms
	video.SetPort(msgPort)	'For screenshots

	serverBase = "http://" + serverAddress + "/"
	url = serverBase + "spot"
	html.SetHWZDefault("on")	'Makes video play smoother, using some for of "overlay"
	html.SetTransform(transform)	'Controls display rotation
	html.ForceGpuRasterization(true)
	html.SetAppCacheDir("SD:/appcache")			'Enable HTML5 app cache
	html.SetLocalStorageDir("SD:/localstorage")	'Enable HTML5 local storage
	html.StartInspectorServer(3041)				'Allow remote debugging using Safari/Chrome
	html.AllowJavaScriptUrls({ all: "*" })		'Allows all BS specific JS objects
	html.EnableSecurity(false)
	'Hide scrollbars inside iframe;
	'html { overflow: hidden !important; } body::-webkit-scrollbar {display: none !important;	width: 0px !important; height:0px !important;}
	html.SetUserStylesheet("data:text/css;charset=utf-8;base64,aHRtbCB7IG92ZXJmbG93OiBoaWRkZW4gIWltcG9ydGFudDsgfSBib2R5Ojotd2Via2l0LXNjcm9sbGJhciB7ZGlzcGxheTogbm9uZSAhaW1wb3J0YW50Owl3aWR0aDogMHB4ICFpbXBvcnRhbnQ7IGhlaWdodDowcHggIWltcG9ydGFudDt9")
	html.EnableScrollbars(false) 'Should be by default set to false (but still shows inside iframe)
	html.SetURL(url)

	sleep(1000)
	html.Show()
	
	'Wire up watchdog timer
	timer = CreateObject("roTimer") 
	timer.SetPort(msgPort)
    timer.SetElapsed(90, 0)
    timer.Start()

	'Fire up web server to serve up screenshot
	'screenshotPath = "/GetScreenshot"
	screenshotFile = "SD:/SCREENSHOT.jpg" 'Must specify an existing directory
	'screenshotPort = 3042
	'webServer = CreateObject("roHttpServer", { port: screenshotPort })
	'webServer.AddGetFromFile({ url_path: screenshotPath, content_type: "image/jpeg", filename: screenshotFile})

	'Attempt to serve entire folder, rather than single file
	webServerConfig = {
		'folder: "SD:/www/screenshot"
		'url_prefix: "pixiData"
		method: "GET"
		content_type: "image/jpeg"
		auth: "digest"
		realm: "screenshots"
		passwords: {
			admin: "pixi"
		}
	}
	'webServer.AddGetFromFolder(webServerConfig)	'Requires 6.1 (Later...)

	'Params used by Screenshot command below
	screenShotParams = {
		filename: screenshotFile
		Width: cint(video.GetOutputResX() / 4)
		Height: cint(video.GetOutputResY() / 4)
		filetype: "JPEG"
		Async: 1
	}

	videoPlayer = CreateObject("roVideoPlayer") 'For switching to HDMI and other external inputs
	uploading = false	'Set while uploading file, to handle event properly

	'Manage browser comms for watchdog and other auxiliary functions not supported in JS land
	while true
		msg = wait(0, msgPort)
		if type(msg) = "roHtmlWidgetEvent" then
			eventData = msg.GetData()
			if type(eventData) = "roAssociativeArray" and type(eventData.reason) = "roString" then
				if eventData.reason = "load-error" then
					print "load-error ";eventData.message
				else if eventData.reason = "message" then
					if eventData.message.msg = "heartbeat"
						'print "heartbeat"
						timer.Stop()	'Restart watchdog timer
						timer.Start()
					else if eventData.message.msg = "screenshot"
						scFilenamePrefix = eventData.message.filenamePrefix ' Passed to roScreenshotComplete
						video.Screenshot(screenShotParams)
					else if eventData.message.msg = "download"
						' Initiate file download. Return false if unable to do so for some reason.
						transferrer = CreateObject("roUrlTransfer")
						transferrer.SetUrl(eventData.message.url)
						transferrer.SetPort(msgPort)
						if not transferrer.AsyncGetToFile(eventData.message.path)
							print "File download failed"
							'Indicate failure by returning falsey result
							html.PostJSMessage({filetransfercomplete: ""})
						endif
					else if eventData.message.msg = "version"
						'Obtain version of this BS script
						html.PostJSMessage({version: scriptVer})
					else if eventData.message.msg = "pictureSource"
						if (eventData.message.source = "HDMI") 'Only supported external source for now
							videoInput = CreateObject("roVideoInput")
							'Could set other input (and mode) through videoInput here
							videoPlayer.PlayFile(videoInput)
						else
							videoPlayer.Stop()
						endif
					else if eventData.message.msg = "reboot"
						RebootSystem()
					else
						print "unrecognized message = ";eventData.message.msg
					endif
				endif
			endif 
		else if type(msg) = "roTimerEvent" then
			print "Watchdog reloading URL"
			html.SetURL(url)
			timer.Start()
		else if type(msg) = "roScreenshotComplete" then
        	'Attempt to upload screenshot to server
        	'print "roScreenShotComplete"
        	uploader = CreateObject("roUrlTransfer")
        	uploader.SetPort(msgPort)
        	'print "uploader SetPort"
        	uploadUrl = serverBase + "rest/upload/urlencoded/screenshot/" + scFilenamePrefix + ".jpg"
        	uploader.SetUrl(uploadUrl)
        	'print "uploader SetUrl " + uploadUrl
        	uploading = uploader.AsyncPostFromFile(screenshotFile)
        	if not uploading 'Failed right off the bat
                html.PostJSMessage({fileuploadcomplete: ""})
			endif
			'OLD method, where I acted as server for the file
        	'Return :<portNumber>/<path> in me where screenshot can be found
        	'portPath = ":3042" + screenshotPath
			'html.PostJSMessage({screenshotcomplete: portPath})
		else if type(msg) = "roUrlEvent" then
			' File transfer status update
			'print "roUrlEvent"
			if msg.GetResponseCode() < 0
				print "roUrlEvent 1 ERROR"
				'print msg.GetResponseCode()
				'print msg.GetFailureReason()
				if uploading
					'Empty string indicates failure
					html.PostJSMessage({fileuploadcomplete: ""})
					uploading = false
				else
					html.PostJSMessage({filetransfercomplete: ""})
				endif
			endif
			if msg.GetInt() = 1 ' means upload complete
				if msg.GetResponseCode() = 200	'Uploaded OK
					print "roUrlEvent OK"
					if uploading
						html.PostJSMessage({fileuploadcomplete: "OK"})
						uploading = false
					else
						html.PostJSMessage({filetransfercomplete: "OK"})
					endif
				else	'Completed with error response
					print "roUrlEvent 2 ERROR"
					'print msg.GetResponseCode()
					'print msg.GetFailureReason()
					if uploading
						'Empty string indicates failure
						html.PostJSMessage({fileuploadcomplete: ""})
					else
						html.PostJSMessage({filetransfercomplete: ""})
					endif
				endif
			endif
        else
        	print "type(msg)=";type(msg)
		endif
	end while
End Sub
